//+------------------------------------------------------------------+
//|                                                           HL.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    Vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "Vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Yellow

//---- input parameters

extern int CalcBars=15;
//---- buffers


double HighBuffer[];
double MidleBuffer[];
double LowBuffer[];
double Candle[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   IndicatorBuffers(4);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   

   SetIndexBuffer(0,HighBuffer);   
   SetIndexBuffer(1,MidleBuffer);
   SetIndexBuffer(2,LowBuffer);    
   SetIndexBuffer(3,Candle);    

   IndicatorShortName("HL");
   SetIndexLabel(0,"High");   
   SetIndexLabel(1,"Midle");   
   SetIndexLabel(2,"Low");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int start() {

   int  counted_bars=IndicatorCounted();
   int  limit=Bars-counted_bars;
   int i;
   if (limit>1) {
      limit=Bars-CalcBars-1;
      for (i=Bars-1;i>limit;i--) Candle[i]=High[i]-Low[i];
   }
   for (i=limit; i>=0; i--) Candle[i]=High[i]-Low[i];
   for (i=limit; i>=0; i--) {
      double tmp=iMAOnArray(Candle,0,CalcBars,0,MODE_SMA,i)/2.0;
      MidleBuffer[i]=(High[i]+Low[i])/2.0;
      HighBuffer[i]=MidleBuffer[i]+tmp;
      LowBuffer[i] =MidleBuffer[i]-tmp;

   }
   return(0);
}